C**********************
C*     COMPARE        *
C**********************

C================================================
C This subroutine sets the number
C of control variables
C================================================
      SUBROUTINE NUMBMOD( N )
      INTEGER N
      N = 3
      END


C================================================
C The subroutine "MODEL" is called by the
C optimization procedure.
C It has to calculate the cost function "FC"
C depending on the parameter vector "X(N)".
C================================================
      SUBROUTINE MODEL( N, X, FC )

      INTEGER N
      REAL    X(N), FC

      REAL A, B, C, D, E, F
      PARAMETER( A =  0.5, B = -0.4, C =  0.2 )
      PARAMETER( D = -0.2, E =  0.1, F = -0.5 )
      REAL    X1, X2, X3, XMOD
      INTEGER I
      REAL    DATAS(10), FAC

C------------------------------------------
C define file tape
C------------------------------------------
CADJ INIT mytape = 'tape'

      FC = 0.0
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      FAC = 0.01*(X1 + X2 + X3)**2

      DO I = 1, 5

        DATAS(I) = I

        X1 = 0.4*X1 + 0.8*X2 - 0.02
        X2 = 0.8*X2 + 0.4*X3 + 0.05
        X3 = 1.1*X3 -     X1 - 0.08

C================================================
C store X1,X2, and X3 instead of recompute them
C A subroutine call is genereated by the AMC
C for every store directive
C================================================
CADJ store X1, X2, X3 = mytape

        XMOD = A*X1 + B*X2 + C*X3
     $       + D*X1*X2 + E*X2*X3 + F*X1*X3

        FC = FC + FAC*(XMOD-DATAS(I))**2

      ENDDO

      END


C================================================
C The subroutine "INMODEL" is called before the
C optimization. It must set a first guess
C of the parameter vector.
C It may also contain the initialization of
C the model.
C================================================
      SUBROUTINE INITMOD( N, X )

      INTEGER N
      REAL    X(N)

      N = 3

      X(1) = 0.1
      X(2) = -0.2
      X(3) = 0.5

      END


C================================================
C The subroutine "POSTMOD" is called after
C the optimization.
C It should contain the output of the results.
C================================================
      SUBROUTINE POSTMOD( N, X, FC )

      INTEGER N
      REAL    X(N), FC
      INTEGER I

      PRINT *,'**************************************'
      PRINT *,'***     RESULT OF OPTIMISATION      **'
      PRINT *,'**************************************'
      PRINT 9010, FC
      PRINT 9020
      DO I = 1,N
        PRINT 9030, I, X(I)
      ENDDO
 9010 FORMAT(1X,'The value of the cost function is : ',E12.6)
 9020 FORMAT(1X,'The optimal parameter values are :')
 9030 FORMAT(1X,I5,2X,E12.6)

      END
