      subroutine admodel( n, x, fc, adx, adfc )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      real a
      parameter ( a = 0.5 )
      real b
      parameter ( b = -0.4 )
      real c
      parameter ( c = 0.2 )
      real d
      parameter ( d = -0.2 )
      real e
      parameter ( e = 0.1 )
      real f
      parameter ( f = -0.5 )

C==============================================
C define arguments
C==============================================
      real adfc
      integer n
      real adx(n)
      real fc
      real x(n)

C==============================================
C define local variables
C==============================================
      real adfac
      real adx1
      real adx2
      real adx3
      real adxmod
      real datas(10)
      real fac
      integer i
      real x1
      real x2
      real x3
      real xmod

C----------------------------------------------
C RESET LOCAL ADJOINT VARIABLES
C----------------------------------------------
      adfac = 0.
      adx1 = 0.
      adx2 = 0.
      adx3 = 0.
      adxmod = 0.

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
C----------------------------------------------
C OPEN FILES OF TAPE: tape
C----------------------------------------------
      open(60,file='tape_1_model_x1',ACCESS='DIRECT',RECL=1*8)
      open(61,file='tape_2_model_x2',ACCESS='DIRECT',RECL=1*8)
      open(62,file='tape_3_model_x3',ACCESS='DIRECT',RECL=1*8)

C----------------------------------------------
C FUNCTION AND TAPE COMPUTATIONS
C----------------------------------------------
      fc = 0.
      x1 = x(1)
      x2 = x(2)
      x3 = x(3)
      fac = 0.01*(x1+x2+x3)**2
      do i = 1, 5
        datas(i) = i
        x1 = 0.4*x1+0.8*x2-0.02
        x2 = 0.8*x2+0.4*x3+0.05
        x3 = 1.1*x3-x1-0.08
        write(60,REC=i) x1
        write(61,REC=i) x2
        write(62,REC=i) x3
        xmod = a*x1+b*x2+c*x3+d*x1*x2+e*x2*x3+f*x1*x3
        fc = fc+fac*(xmod-datas(i))**2
      end do

C----------------------------------------------
C ADJOINT COMPUTATIONS
C----------------------------------------------
      do i = 5, 1, -1
        datas(i) = i
        read(60,REC=i) x1
        read(61,REC=i) x2
        read(62,REC=i) x3
        xmod = a*x1+b*x2+c*x3+d*x1*x2+e*x2*x3+f*x1*x3
        adfac = adfac+adfc*(xmod-datas(i))**2
        adxmod = adxmod+2*adfc*fac*(xmod-datas(i))
        adx1 = adx1+adxmod*(a+d*x2+f*x3)
        adx2 = adx2+adxmod*(b+d*x1+e*x3)
        adx3 = adx3+adxmod*(c+e*x2+f*x1)
        adxmod = 0.
        adx1 = adx1-adx3
        adx3 = 1.1*adx3
        adx3 = adx3+0.4*adx2
        adx2 = 0.8*adx2
        adx2 = adx2+0.8*adx1
        adx1 = 0.4*adx1
      end do
      x1 = x(1)
      x2 = x(2)
      x3 = x(3)
      adx1 = adx1+0.02*adfac*(x1+x2+x3)
      adx2 = adx2+0.02*adfac*(x1+x2+x3)
      adx3 = adx3+0.02*adfac*(x1+x2+x3)
      adfac = 0.
      adx(3) = adx(3)+adx3
      adx3 = 0.
      adx(2) = adx(2)+adx2
      adx2 = 0.
      adx(1) = adx(1)+adx1
      adx1 = 0.

C----------------------------------------------
C CLOSE FILES OF TAPE: tape
C----------------------------------------------
      close(60)
      close(61)
      close(62)


      end


