C**********************
C*     FACTOR_2       *
C**********************

C================================================
C This subroutine sets the number
C of control variables
C================================================
      SUBROUTINE NUMBMOD( N )
      INTEGER N
      N = 10
      END

C================================================
C The subroutine "MODEL" is called by the
C optimization procedure.
C It has to calculate the cost function "FC"
C depending on the control vector "X(N)".
C================================================
      SUBROUTINE MODEL( N, X, FC )
      INTEGER N
      REAL    X(N), FC
      INTEGER I

C------------------------------------------
C define dynamic memory tape
C------------------------------------------
CADJ INIT mytape = memory

      FC = 1.0
      DO I = 1, N
C------------------------------------------
C store variable FC on tape
C------------------------------------------
CADJ STORE FC = mytape

        FC = FC * X(I)
      ENDDO

      END

C================================================
C The subroutine "INITMOD" is called before the
C optimization. It must set a first guess
C of the parameter vector.
C It may also contain the initialization of
C the model.
C================================================
      SUBROUTINE INITMOD( N, X )

      INTEGER N
      REAL    X(N)

      DO I = 1, N
        X(I) = 1.0 + (I-(N/2))*0.04
      ENDDO

      END

C================================================
C The subroutine "POSTMOD" is called after
C the optimization.
C It should contain the output of the results.
C================================================
      SUBROUTINE POSTMOD( N, X, FC, ADX )

      INTEGER N
      REAL    X(N), FC, ADX(N)
      INTEGER I

      PRINT *,'**************************************'
      PRINT *,'***     RESULT OF OPTIMISATION      **'
      PRINT *,'**************************************'
      PRINT 9010, FC
      PRINT 9020
      DO I = 1,N
        PRINT 9030, I, X(I), ADX(I)
      ENDDO
 9010 FORMAT(1X,'The value of the cost function is : ',E15.9)
 9020 FORMAT(1X,'The optimal parameter values, gradients are :')
 9030 FORMAT(1X,I5,1X,E15.9,1X,E15.9)

      END
