
      subroutine numbmod( n )
C*********************************************************
C set number of control variables
C*********************************************************
      implicit none

      integer n
      integer nmax
      parameter( nmax = 10 )

      n = nmax

      end


      subroutine initmod( n, x )
C*********************************************************
C initialize model and vector of control variables
C*********************************************************
      implicit none

c--------------------------------------
c arguments
c--------------------------------------
      integer n
      REAL    x(n)

c--------------------------------------
c global variables
c--------------------------------------
      integer nmax
      parameter( nmax = 10 )

      REAL    a, b
      common /matrix/ a(nmax,nmax), b(nmax)

c--------------------------------------
c local variables
c--------------------------------------
      integer i, j

c--------------------------------------
c--------------------------------------
      do j = 1, n
         do i = 1, n
            a(i,j) = float(i)/float(j) + float(j)/float(i)
         end do
      end do

c--------------------------------------
c--------------------------------------
      do i = 1, n
CC         b(i) = sin(2*3.1415926*float(i-1)/float(n-1))
         b(i) = 0.4
      end do

c--------------------------------------
c--------------------------------------
      do i = 1, n
         x(i) = 1.0/float(n+1)
      end do

      end



      subroutine model( n, x, fc )
C*********************************************************
C compute cost function
C*********************************************************
      implicit none

c--------------------------------------
c arguments
c--------------------------------------
      integer n
      REAL    x(n), fc

c--------------------------------------
c global variables
c--------------------------------------
      integer nmax
      parameter( nmax = 10 )

      REAL    a, b
      common /matrix/ a(nmax,nmax), b(nmax)

c--------------------------------------
c rt = ?????
c--------------------------------------
      REAL       rt
      parameter( rt = 1.234567 )

c--------------------------------------
c local variables
c--------------------------------------
      REAL    btx, xax, ss, t1
      integer i, j

c--------------------------------------
c compute  btx = b^T * x
c--------------------------------------
      btx = 0.0
      do i = 1, n
         btx = btx + b(i)*x(i)
      end do

c--------------------------------------
c compute xax = x^T A x
c--------------------------------------
      xax = 0.0
      do i = 1, n
         ss = 0.0
         do j = 1, n
            ss = ss + a(i,j)*x(j)
         end do
         xax = xax + x(i)*ss
      end do

c--------------------------------------
c store computed value or not
c--------------------------------------
C=== CADJ store xax = file

c--------------------------------------
c compute
c  rt SUM_{i=1}^{n} x_I^2/(1 - b^T x)
c--------------------------------------
      t1 = 0.0
      do i = 1, n
         t1 = t1 + x(i)*log( x(i)/(1.0-btx) )
      end do

c--------------------------------------
c compute
c     xAx          1+(1+sqrt(2))b^Tx
c ----------- log( ----------------- )
c sqrt(8)b^Tx      1+(1-sqrt(2))b^Tx
c--------------------------------------
      fc = rt * t1
     $   - (xax/(sqrt(8.0)*btx)) * log(
     $  (1.0 + (1.0+sqrt(2.0))*btx) / (1.0 + (1.0+sqrt(2.0))*btx)
     $                               )

      fc = (fc-2.0)**2

      end

