      subroutine admodel( n, x, fc, adx, adfc )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer nmax
      parameter ( nmax = 10 )
      real rt
      parameter ( rt = 1.234567 )

C==============================================
C define common blocks
C==============================================
      common /matrix/ a, b
      real a(nmax,nmax)
      real b(nmax)

C==============================================
C define arguments
C==============================================
      real adfc
      integer n
      real adx(n)
      real fc
      real x(n)

C==============================================
C define local variables
C==============================================
      real adbtx
      real adss
      real adt1
      real adxax
      real btx
      real fch
      integer i
      integer j
      real ss
      real t1
      real xax

C----------------------------------------------
C RESET LOCAL ADJOINT VARIABLES
C----------------------------------------------
      adbtx = 0.
      adss = 0.
      adt1 = 0.
      adxax = 0.

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
C----------------------------------------------
C FUNCTION AND TAPE COMPUTATIONS
C----------------------------------------------
      btx = 0.
      do i = 1, n
        btx = btx+b(i)*x(i)
      end do
      xax = 0.
      do i = 1, n
        ss = 0.
        do j = 1, n
          ss = ss+a(i,j)*x(j)
        end do
        xax = xax+x(i)*ss
      end do
      t1 = 0.
      do i = 1, n
        t1 = t1+x(i)*log(x(i)/(1.-btx))
      end do
      fc = rt*t1-xax/(sqrt(8.)*btx)*log((1.+(1.+sqrt(2.))*btx)/(1.+(1.+
     $sqrt(2.))*btx))
      fc = (fc-2.)**2

C----------------------------------------------
C SAVE DEPENDEND VARIABLES
C----------------------------------------------
      fch = fc

C----------------------------------------------
C ADJOINT COMPUTATIONS
C----------------------------------------------
      fc = rt*t1-xax/(sqrt(8.)*btx)*log((1.+(1.+sqrt(2.))*btx)/(1.+(1.+
     $sqrt(2.))*btx))
      adfc = 2*adfc*(fc-2.)
      adbtx = adbtx-adfc*(xax/(btx*sqrt(8.))*1./((1.+(1.+sqrt(2.))*btx)/
     $(1.+(1.+sqrt(2.))*btx))*((1+sqrt(2.))/(1.+(1.+sqrt(2.))*btx)-(1.+
     $(1.+sqrt(2.))*btx)*(1+sqrt(2.))/((1.+(1.+sqrt(2.))*btx)*(1.+(1.+
     $sqrt(2.))*btx)))-xax*sqrt(8.)/(btx*btx*sqrt(8.)*sqrt(8.))*log((1.+
     $(1.+sqrt(2.))*btx)/(1.+(1.+sqrt(2.))*btx)))
      adt1 = adt1+adfc*rt
      adxax = adxax-adfc/(btx*sqrt(8.))*log((1.+(1.+sqrt(2.))*btx)/(1.+
     $(1.+sqrt(2.))*btx))
      adfc = 0.
      do i = 1, n
        adbtx = adbtx+adt1*x(i)*1./(x(i)/(1.-btx))*(x(i)/((1.-btx)*(1.-
     $btx)))
        adx(i) = adx(i)+adt1*(x(i)*(1./(x(i)/(1.-btx))/(1.-btx))+
     $log(x(i)/(1.-btx)))
      end do
      do i = 1, n
        adss = 0.
        ss = 0.
        do j = 1, n
          ss = ss+a(i,j)*x(j)
        end do
        adss = adss+adxax*x(i)
        adx(i) = adx(i)+adxax*ss
        do j = 1, n
          adx(j) = adx(j)+adss*a(i,j)
        end do
        adss = 0.
      end do
      do i = 1, n
        adx(i) = adx(i)+adbtx*b(i)
      end do

C----------------------------------------------
C GET DEPENDEND VARIABLES
C----------------------------------------------
      fc = fch


      end


