C================================================
C This function sets the number
C of control variables
C================================================
      SUBROUTINE NUMBMOD( N )
      integer N
      N = 3
      END


      SUBROUTINE INITMOD( N, X )
      integer N
      REAL    X(N)

      X(1) = 0.1
      X(2) = -0.2
      X(3) = 0.5

      END


C======================================================================
      subroutine model(n,x,fc)


c==================================================
c     declaration part
c==================================================
      integer n
      REAL    x(n)
      REAL    fc
      REAL    s2

c==================================================
c matrix 
c
c         10 -S2   S2
c 1/4 *  -S2   7   -3
c         S2  -3    7
c
c eigenvalues and vectors :
c
c    1.0          0.5* ( 0, S2, S2 )
c    2.0          0.5* (S2,  1, -1 )
c    3.0          0.5* (S2, -1,  1 )
c==================================================
      s2 = sqrt(2.)

      fc = 10*x(1)**2   +  7*x(2)**2   +  7*x(3)**2
     $   - 2*s2*x(1)*x(2) + 2*s2*x(1)*x(3) -  2*3*x(2)*x(3)

      fc = fc/8.

      end


C================================================
      SUBROUTINE POSTMOD( N, X, FC, ADX )

      integer N
      REAL X(N), FC, ADX(N)
      integer I

      PRINT *,'**************************************'
      PRINT *,'***     RESULT OF OPTIMISATION      **'
      PRINT *,'**************************************'
      PRINT 9010, FC
      PRINT 9020
      DO I = 1,N
        PRINT 9030, I, X(I), ADX(I)
      ENDDO
 9010 FORMAT(1X,'The value of the costfunction is : ',E15.9)
 9020 FORMAT(1X,'The optimal parameter values, gradients are :')
 9030 FORMAT(1X,I5,1X,E15.9,1X,E15.9)

      END


C================================================
      SUBROUTINE POSTHES( N, XHESS, EIGVAL, EIGVEC )

      integer N
      REAL    XHESS(N,N), EIGVAL(N), EIGVEC(N,N)

      integer I, J

C===============================================
C print eigenvalues and eigenvectors
C===============================================
      PRINT *
      PRINT *,'   nr   eigenvalue       eigenvector '
      DO J = 1,N
        PRINT '(I5,X,E12.6,A,10(1X,E12.6))'
     $        , J, EIGVAL(J), ' +++ ', (EIGVEC(I,J),I=1,N)
      ENDDO

      END

