C================================================
C This subroutine sets the number
C of control variables
C================================================
      subroutine numbmod( n )
      integer n
      integer nx, ny
      parameter( nx = 7, ny = 7 )
      n = nx*ny
      end


C================================================
      subroutine initmod( n, X )

      implicit none

      integer nx, ny
      parameter( nx = 7, ny = 7 )

      integer n, i
      REAL    x(n)

      do i = 1, n
        x(i) = 0.1*i
      end do

      end


C======================================================================
      subroutine model(nn,x,fc)

      integer nx, ny
      parameter( nx = 7, ny = 7 )

      integer nn
      REAL    x(nx,ny)
      REAL    fc

      integer i, j, im1, ip1, jm1, jp1

      fc = 0.0
      do j = 2,ny-1
        jm1 = 1 + mod( ny+j-2, ny )
        jp1 = 1 + mod(      j, ny )
        do i = 1,nx
           im1 = 1 + mod( nx+i-2, nx )
           ip1 = 1 + mod(      i, nx )
           fc = fc + (  0.2*j*x(ip1,j) + 0.4*i*x(im1,j)
     >                - 0.3*4*x(i,j) + 0.2 
     >                + 0.1*x(i,jp1) + 1.3*x(i,jm1) )**2
        end do
      end do

      end


C======================================================================
      SUBROUTINE POSTMOD( N, X, FC, ADX )

      integer N
      REAL    X(N), FC, ADX(N)
      integer I

      PRINT *,'**************************************'
      PRINT *,'***     RESULT OF OPTIMISATION      **'
      PRINT *,'**************************************'
      PRINT 9010, FC
      PRINT 9020
      DO I = 1,N
        PRINT 9030, I, X(I), ADX(I)
      ENDDO
 9010 FORMAT(1X,'The value of the cost function is : ',E15.9)
 9020 FORMAT(1X,'The optimal parameter values, gradients are :')
 9030 FORMAT(1X,I5,1X,E15.9,1X,E15.9)

      END


C================================================
      subroutine POSTHES( n, XHESS, eigVAL, eigVEC )

      integer n
      REAL    XHESS(n,n), eigVAL(n), eigVEC(n,n)

      integer I, J

C===============================================
C print eigenvalues and eigenvectors
C===============================================
      print *
      print *,'   nr   eigenvalue       eigenvector '
      do J = 1,n
        print '(I5,X,E12.6,A,10(1X,E12.6))'
     $        , J, eigVAL(J), ' +++ ', (eigVEC(I,J),I=1,n)
      enddo

      end

