      subroutine admodel( n, x, fc, adx, adfc )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define arguments
C==============================================
      real adfc
      integer n
      real adx(n)
      real fc
      real x(n)

C==============================================
C define local variables
C==============================================
      real s2

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
C----------------------------------------------
C FUNCTION AND TAPE COMPUTATIONS
C----------------------------------------------
      s2 = sqrt(2.)
      fc = 10*x(1)**2+7*x(2)**2+7*x(3)**2-2*s2*x(1)*x(2)+2*s2*x(1)*x(3)-
     $2*3*x(2)*x(3)
      fc = fc/8.

C----------------------------------------------
C ADJOINT COMPUTATIONS
C----------------------------------------------
      adfc = 0.125*adfc
      adx(3) = adx(3)+adfc*(14*x(3)+2*s2*x(1)-6*x(2))
      adx(2) = adx(2)+adfc*(14*x(2)-2*s2*x(1)-6*x(3))
      adx(1) = adx(1)+adfc*(20*x(1)-2*s2*x(2)+2*s2*x(3))
      adfc = 0.


      end


      SUBROUTINE CSTGRAD( N, X, FC, ADX )
C********************************************************************
C
C input  : N      amount of parameters
C          X      array of parameters
C
C output : FC     value of cost function
C          ADX    gradient of cost function
C
C********************************************************************
      IMPLICIT NONE

      INTEGER N
      REAL    X(N), FC, ADX(N), ADFC
      INTEGER I

C==============================================
C initialize adjoint variables
C==============================================
      DO I = 1, N
        ADX(I) = 0.0
      END DO
      ADFC = 1.0

C==============================================
C compute gradient and cost function
C==============================================
      CALL ADMODEL ( N, X, FC, ADX, ADFC )

      END
