      SUBROUTINE NUMBMOD( N )
      INTEGER N
      N = 70
      END

      SUBROUTINE INITMOD( N, X )
      INTEGER N
      REAL    X(N)
      do i = 1, n
        x(i) = 0.2 + 0.01*i
      end do
      end


      subroutine model( n, x, fc )
      implicit none
      integer n
      REAL    x(n), fc

      double precision d, e, dfc
      complex c, cfc

      fc = 0.0

      fc = fc + sin(x(1))
      fc = fc + cos(x(2))
      fc = fc + tan(x(3))

      fc = fc + asin(x(4))
      fc = fc + acos(x(5))
      fc = fc + atan(x(6))
      fc = fc + atan2(x(7),x(8))

      fc = fc + sinh(x(9))
      fc = fc + cosh(x(10))
      fc = fc + tanh(x(11))

      fc = fc + exp(x(12))
      fc = fc + log(x(13))
      fc = fc + alog(x(14))
      fc = fc + log10(x(15))
      fc = fc + alog10(x(16))

      fc = fc + sqrt(x(17))
      fc = fc + amax1(x(18)+1.0,x(19))
      fc = fc + amax1(x(18)    ,x(19)+1.0)
      fc = fc + amin1(x(20)+1.0,x(21))
      fc = fc + amin1(x(20)    ,x(21)+1.0)

      fc = fc + max(x(22)+1.0,x(23))
      fc = fc + max(x(22)    ,x(23)+1.0)
      fc = fc + min(x(24)+1.0,x(25))
      fc = fc + min(x(24)    ,x(25)+1.0)


      dfc = 0.0
      d = x(31)
      dfc = dfc + dsin(d)
      d = x(32)
      dfc = dfc + dcos(d)
      d = x(33)
      dfc = dfc + dtan(d)

      d = x(34)
      dfc = dfc + dasin(d)
      d = x(35)
      dfc = dfc + dacos(d)
      d = x(36)
      dfc = dfc + datan(d)
      d = x(37)
      e = x(38)
      dfc = dfc + datan2(d,e)

      d = x(39)
      dfc = dfc + dsinh(d)
      d = x(40)
      dfc = dfc + dcosh(d)
      d = x(41)
      dfc = dfc + dtanh(d)

      d = x(42)
      dfc = dfc + dexp(d)
      d = x(43)
      dfc = dfc + dlog(d)
      d = x(45)
      dfc = dfc + dlog10(d)

      d = x(46)
      dfc = dfc + dsqrt(d)
      d = x(47)
      e = x(48)
      dfc = dfc + dmax1(d+1.0,e)
      dfc = dfc + dmax1(d    ,e+1.0)
      d = x(49)
      e = x(50)
      dfc = dfc + dmin1(d+1.0,e)
      dfc = dfc + dmin1(d    ,e+1.0)

      fc = fc + float(dfc)

      cfc = cmplx( 0., 0. )

      c  = cmplx( x(51), x(52) )
      cfc = cfc + c

      c  = cmplx( x(53), x(54) )
      fc = fc + cabs(c)

      c  = cmplx( x(55), x(56) )
      cfc = cfc + conjg(c)

      c  = cmplx( x(57), x(58) )
      fc = fc + abs(c)

      c  = cmplx( x(59), x(60) )
      cfc = cfc + cexp(c)

      c  = cmplx( x(61), x(62) )
      cfc = cfc + clog(c)

      c  = cmplx( x(63), x(64) )
      cfc = cfc + csqrt(c)

      c  = cmplx( x(65), x(66) )
      cfc = cfc + csin(c)

      c  = cmplx( x(67), x(68) )
      cfc = cfc + ccos(c)

      fc = fc + cabs(cfc)

      c = cmplx( x(69), x(70) )
      fc = fc + 2.*real(c)
      fc = fc + 3.*aimag(c)



      end




      SUBROUTINE POSTMOD( N, X, FC, ADX )

      INTEGER N
      REAL    X(N), FC, ADX(N)
      INTEGER I

      PRINT *,'**************************************'
      PRINT *,'***     RESULT OF OPTIMISATION      **'
      PRINT *,'**************************************'
      PRINT 9010, FC
      PRINT 9020
      DO I = 1,N
        PRINT 9030, I, X(I), ADX(I)
      ENDDO
 9010 FORMAT(1X,'The value of the cost function is : ',E15.9)
 9020 FORMAT(1X,'The optimal parameter values, gradients are :')
 9030 FORMAT(1X,I5,1X,E15.9,1X,E15.9)

      END








