C**********************
C*     JACOB_1        *
C**********************

C================================================
C This subroutine sets the number
C of independend and dependend variables
C================================================
      SUBROUTINE SETFUNC( N, M )
      INTEGER N, M
      N = 3
      M = 3
      END

C================================================
C This is the top level routine,
C it has to calculate the dependend variables Y(M)
C out of the independend variables X(N)
C================================================
      SUBROUTINE FUNC( N, X, M, Y )
      INTEGER N, M
      REAL    X(N), Y(M)

      REAL    SUM
      INTEGER I, J

      DO J = 1, M
        SUM = 0.0
        DO I = 1, N
          SUM = SUM + (I+10*J)*X(I)
        ENDDO
        Y(J) = SUM
      ENDDO

      END

C================================================
C The subroutine INITFUNC
C must set the independent variables
C================================================
      SUBROUTINE INITFUNC( N, X )

      INTEGER N
      REAL    X(N)

      X(1) = 0.8
      X(2) = 0.9
      X(3) = 0.5

      END


C================================================
C The subroutine "POSTFUNC" is called at last
C It should contain the output of the results.
C================================================
      SUBROUTINE POSTFUNC( N, X, M, Y, GDX, LDX )

      INTEGER N, M, LDX
      REAL    X(N), Y(M), GDX(LDX,M)
      INTEGER I

      PRINT *,'**************************************'
      PRINT *,'***         FULL JACOBIAN           **'
      PRINT *,'**************************************'
      DO J = 1,M
         PRINT '(X,I4,20(X,E12.6))', J, (GDX(I,J),I=1,N)
      ENDDO

      END
