      subroutine adfunc( n, x, m, y, adp_, adx, ldx, ady, ldy )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer adpmax
      parameter ( adpmax = 3 )

C==============================================
C define arguments
C==============================================
      integer adp_
      integer ldx
      integer n
      real adx(ldx,n)
      integer ldy
      integer m
      real ady(ldy,m)
      real x(n)
      real y(m)

C==============================================
C define local variables
C==============================================
      integer adi_
      real adsum(adpmax)
      integer i
      integer ip1
      integer j
      real sum

C----------------------------------------------
C CHECK PACT LOWER EQUAL PMAX
C----------------------------------------------
      if (adp_ .gt. adpmax) then
        stop 'error : pact is greater than pmax'
      endif

C----------------------------------------------
C RESET LOCAL ADJOINT VARIABLES
C----------------------------------------------
      do ip1 = 1, adpmax
        adsum(ip1) = 0.
      end do

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
C----------------------------------------------
C FUNCTION AND TAPE COMPUTATIONS
C----------------------------------------------
      do j = 1, m
        sum = 0.
        do i = 1, n
          sum = sum+(i+10*j)*x(i)
        end do
        y(j) = sum
      end do

C----------------------------------------------
C ADJOINT COMPUTATIONS
C----------------------------------------------
      do j = 1, m
        do adi_ = 1, adp_
          adsum(adi_) = adsum(adi_)+ady(adi_,j)
          ady(adi_,j) = 0.
        end do
        do i = 1, n
          do adi_ = 1, adp_
            adx(adi_,i) = adx(adi_,i)+adsum(adi_)*(i+10*j)
          end do
        end do
        do adi_ = 1, adp_
          adsum(adi_) = 0.
        end do
      end do


      end


