      subroutine g_cost( itt, umod, vmod, emod, fc, g_umod, g_vmod, 
     $g_emod, g_fc )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer im
      parameter ( im = 18 )
      integer itte
      parameter ( itte = 100 )
      integer jm
      parameter ( jm = 30 )

C==============================================
C define common blocks
C==============================================
      common /modoup/ ud, vd, ed
      real ed(im,jm,0:itte)
      real ud(im,jm,0:itte)
      real vd(im,jm,0:itte)

C==============================================
C define arguments
C==============================================
      real emod(im,jm)
      real fc
      real g_emod(im,jm)
      real g_fc
      real g_umod(im,jm)
      real g_vmod(im,jm)
      integer itt
      real umod(im,jm)
      real vmod(im,jm)

C==============================================
C define local variables
C==============================================
      integer i
      integer j

C----------------------------------------------
C TANGENT LINEAR AND FUNCTION STATEMENTS
C----------------------------------------------
      g_fc = 0.
      fc = 0.
      do i = 1, im
        do j = 1, jm
          g_fc = 2*g_emod(i,j)*(emod(i,j)-ed(i,j,itt))+g_fc+2*g_umod(i,
     $j)*(umod(i,j)-ud(i,j,itt))+2*g_vmod(i,j)*(vmod(i,j)-vd(i,j,itt))
          fc = fc+(umod(i,j)-ud(i,j,itt))**2+(vmod(i,j)-vd(i,j,itt))**2+
     $(emod(i,j)-ed(i,j,itt))**2
        end do
      end do

      end


      subroutine g_model( nn, x, fc, g_x, g_fc )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer im
      parameter ( im = 18 )
      integer jm
      parameter ( jm = 30 )
      integer nouter
      parameter ( nouter = 3 )

C==============================================
C define common blocks
C==============================================
      common /lo1/ mp
      integer mp

      common /rscala1/ pi, dt2, degrad, epsln, dt, secpday, one, zero, 
     $eighth, quarter, half, two, four, depthr, omega, days, avgper, 
     $ittend
      real avgper
      real days
      real degrad
      real depthr
      real dt
      real dt2
      real eighth
      real epsln
      real four
      real half
      integer ittend
      real omega
      real one
      real pi
      real quarter
      real secpday
      real two
      real zero

C==============================================
C define arguments
C==============================================
      real fc
      real g_fc
      integer nn
      real g_x(nn)
      real x(nn)

C==============================================
C define local variables
C==============================================
      real e1(im,jm)
      real e2(im,jm)
      real e3(im,jm)
      real fc1
      real fr
      real g_e1(im,jm)
      real g_e2(im,jm)
      real g_e3(im,jm)
      real g_fc1
      real g_fr
      real g_u1(im,jm)
      real g_u2(im,jm)
      real g_u3(im,jm)
      real g_v1(im,jm)
      real g_v2(im,jm)
      real g_v3(im,jm)
      integer i
      integer iout
      integer itt
      integer j
      integer loc
      integer loce
      integer loceu
      integer mp1
      integer mp2
      real u1(im,jm)
      real u2(im,jm)
      real u3(im,jm)
      real v1(im,jm)
      real v2(im,jm)
      real v3(im,jm)

C----------------------------------------------
C TANGENT LINEAR AND FUNCTION STATEMENTS
C----------------------------------------------
      g_fc = 0.
      fc = 0.
      do j = 1, jm
        do i = 1, im
          g_u1(i,j) = 0.
          u1(i,j) = zero
          g_v1(i,j) = 0.
          v1(i,j) = zero
          g_e1(i,j) = 0.
          e1(i,j) = zero
        end do
      end do
      loc = 0
      do j = 1, jm-1
        mp = (j-1)*(im-1)
        do i = 1, im-1
          loc = loc+1
          g_e1(i,j) = 1.e+4*g_x(mp+i)
          e1(i,j) = x(mp+i)*1.e+4
        end do
      end do
      loce = loc
      do j = 1, jm-1
        mp1 = (j-1)*(im-1)
        do i = 2, im
          loc = loc+1
          g_u1(i,j) = g_x(mp1+i-1+loce)
          u1(i,j) = x(mp1+i-1+loce)
        end do
      end do
      loceu = loc
      do j = 2, jm
        mp2 = (j-2)*(im-1)
        do i = 1, im-1
          loc = loc+1
          g_v1(i,j) = g_x(mp2+i+loceu)
          v1(i,j) = x(mp2+i+loceu)
        end do
      end do
      g_fr = 1.e-6*g_x(loc+1)
      fr = x(loc+1)/1.e+6
      call g_cost( 2,u1,v1,e1,fc1,g_u1,g_v1,g_e1,g_fc1 )
      g_fc = g_fc+g_fc1
      fc = fc+fc1
      call g_step( dt,fr,u1,v1,e1,u1,v1,e1,u2,v2,e2,g_fr,g_u1,g_v1,g_e1,
     $g_u1,g_v1,g_e1,g_u2,g_v2,g_e2 )
      call g_cost( 2,u2,v2,e2,fc1,g_u2,g_v2,g_e2,g_fc1 )
      g_fc = g_fc+g_fc1
      fc = fc+fc1
      do iout = 1, nouter
        do itt = 1, ittend, 3
          call g_step( dt2,fr,u1,v1,e1,u2,v2,e2,u3,v3,e3,g_fr,g_u1,g_v1,
     $g_e1,g_u2,g_v2,g_e2,g_u3,g_v3,g_e3 )
          call g_cost( itt,u3,v3,e3,fc1,g_u3,g_v3,g_e3,g_fc1 )
          call g_step( dt2,fr,u2,v2,e2,u3,v3,e3,u1,v1,e1,g_fr,g_u2,g_v2,
     $g_e2,g_u3,g_v3,g_e3,g_u1,g_v1,g_e1 )
          call g_cost( itt,u1,v1,e1,fc1,g_u1,g_v1,g_e1,g_fc1 )
          call g_step( dt2,fr,u3,v3,e3,u1,v1,e1,u2,v2,e2,g_fr,g_u3,g_v3,
     $g_e3,g_u1,g_v1,g_e1,g_u2,g_v2,g_e2 )
          call g_cost( itt,u2,v2,e2,fc1,g_u2,g_v2,g_e2,g_fc1 )
          g_fc = g_fc+g_fc1
          fc = fc+fc1
        end do
      end do

      end


      subroutine g_step( ddt, fr, uold, vold, eold, uact, vact, eact, 
     $unew, vnew, enew, g_fr, g_uold, g_vold, g_eold, g_uact, g_vact, 
     $g_eact, g_unew, g_vnew, g_enew )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer im
      parameter ( im = 18 )
      integer jm
      parameter ( jm = 30 )

C==============================================
C define common blocks
C==============================================
      common /coef/ cf, c3, c4, c5, c5a, c6, c7, c8, c8a, c9
      real c3(jm)
      real c4(jm)
      real c5(jm)
      real c5a(im)
      real c6(jm)
      real c7(jm)
      real c8(jm)
      real c8a(im)
      real c9(jm)
      real cf(jm)

      common /g_var4/ g_uh, g_vh
      real g_uh(im,jm)
      real g_vh(im,jm)

      common /masks/ be, bu, bv
      real be(im,jm)
      real bu(im,jm)
      real bv(im,jm)

      common /rscala1/ pi, dt2, degrad, epsln, dt, secpday, one, zero, 
     $eighth, quarter, half, two, four, depthr, omega, days, avgper, 
     $ittend
      real avgper
      real days
      real degrad
      real depthr
      real dt
      real dt2
      real eighth
      real epsln
      real four
      real half
      integer ittend
      real omega
      real one
      real pi
      real quarter
      real secpday
      real two
      real zero

      common /rscala2/ grav, depth, rober, eanom, escale, txanom, 
     $txscale
      real depth
      real eanom
      real escale
      real grav
      real rober
      real txanom
      real txscale

      common /var4/ h, uh, vh, z
      real h(im,jm)
      real uh(im,jm)
      real vh(im,jm)
      real z(im,jm)

C==============================================
C define arguments
C==============================================
      real ddt
      real eact(im,jm)
      real enew(im,jm)
      real eold(im,jm)
      real fr
      real g_eact(im,jm)
      real g_enew(im,jm)
      real g_eold(im,jm)
      real g_fr
      real g_uact(im,jm)
      real g_unew(im,jm)
      real g_uold(im,jm)
      real g_vact(im,jm)
      real g_vnew(im,jm)
      real g_vold(im,jm)
      real uact(im,jm)
      real unew(im,jm)
      real uold(im,jm)
      real vact(im,jm)
      real vnew(im,jm)
      real vold(im,jm)

C==============================================
C define local variables
C==============================================
      integer i
      integer j

C----------------------------------------------
C TANGENT LINEAR AND FUNCTION STATEMENTS
C----------------------------------------------
      do j = 1, jm
        do i = 2, im
          g_uh(i,j) = g_uact(i,j)*half*(h(i,j)+h(i-1,j))*bu(i,j)
          uh(i,j) = half*(h(i,j)+h(i-1,j))*uact(i,j)*bu(i,j)
        end do
      end do
      do j = 2, jm
        do i = 1, im
          g_vh(i,j) = g_vact(i,j)*half*(h(i,j)+h(i,j-1))*bv(i,j)
          vh(i,j) = half*(h(i,j)+h(i,j-1))*vact(i,j)*bv(i,j)
        end do
      end do
      do j = 1, jm-1
        do i = 2, im
          g_unew(i,j) = g_eact(i-1,j)*ddt*bu(i,j)*c5(j)*c5a(i)*grav-
     $g_eact(i,j)*ddt*bu(i,j)*c5(j)*c5a(i)*grav-g_fr*ddt*bu(i,j)*uold(i,
     $j)+g_uold(i,j)*(1-ddt*bu(i,j)*fr)+(g_vh(i-1,j+1)+g_vh(i,j+1))*ddt*
     $bu(i,j)*c4(j)*(z(i,j)+z(i,j+1))*c3(j+1)+(g_vh(i-1,j)+g_vh(i,j))*
     $ddt*bu(i,j)*c4(j)*(z(i,j)+z(i,j+1))*c3(j)
          unew(i,j) = uold(i,j)+ddt*bu(i,j)*(c4(j)*(z(i,j)+z(i,j+1))*
     $((vh(i,j)+vh(i-1,j))*c3(j)+(vh(i,j+1)+vh(i-1,j+1))*c3(j+1))-c5(j)*
     $c5a(i)*grav*(eact(i,j)-eact(i-1,j))-fr*uold(i,j))
        end do
      end do
      do j = 2, jm
        do i = 1, im-1
          g_vnew(i,j) = g_eact(i,j-1)*ddt*bv(i,j)*c6(j)*grav-g_eact(i,j)
     $*ddt*bv(i,j)*c6(j)*grav-g_fr*ddt*bv(i,j)*vold(i,j)-g_uh(i+1,j-1)*
     $ddt*bv(i,j)*eighth*(z(i,j)+z(i+1,j))-g_uh(i,j-1)*ddt*bv(i,j)*
     $eighth*(z(i,j)+z(i+1,j))-g_uh(i+1,j)*ddt*bv(i,j)*eighth*(z(i,j)+
     $z(i+1,j))-g_uh(i,j)*ddt*bv(i,j)*eighth*(z(i,j)+z(i+1,j))+g_vold(i,
     $j)*(1-ddt*bv(i,j)*fr)
          vnew(i,j) = vold(i,j)+ddt*bv(i,j)*((-(eighth*(z(i,j)+z(i+1,j))
     $*(uh(i,j)+uh(i+1,j)+uh(i,j-1)+uh(i+1,j-1))))-c6(j)*grav*(eact(i,j)
     $-eact(i,j-1))-fr*vold(i,j))
        end do
      end do
      do j = 1, jm-1
        do i = 1, im-1
          g_enew(i,j) = g_eold(i,j)-g_uh(i+1,j)*ddt*depthr*h(i,j)*c8(j)*
     $c8a(i)+g_uh(i,j)*ddt*depthr*h(i,j)*c8(j)*c8a(i)-g_vh(i,j+1)*ddt*
     $depthr*h(i,j)*c9(j)*c3(j+1)+g_vh(i,j)*ddt*depthr*h(i,j)*c9(j)*
     $c3(j)
          enew(i,j) = eold(i,j)+ddt*depthr*h(i,j)*((-(c8(j)*c8a(i)*
     $(uh(i+1,j)-uh(i,j))))-c9(j)*(vh(i,j+1)*c3(j+1)-vh(i,j)*c3(j)))
        end do
      end do

      end


