C**********************
C*     OPTIM          *
C**********************

C================================================
C This subroutine sets the number
C of control variables
C================================================
      SUBROUTINE NUMBMOD( N )
      INTEGER N
      N = 10
      END

C================================================
C The subroutine "MODEL" is called by the
C optimization procedure.
C It has to calculate the cost function "FC"
C depending on the control vector "X(N)".
C================================================
      SUBROUTINE MODEL( N, X, FC )
      INTEGER N
      REAL    X(N), FC
      INTEGER I, IC

      FC = 0.0
      DO I = 1,N
        IC = N+1-I
        FC = FC +      (X(I)-1.0-0.1*I)**2
     $          + 0.05*(X(I)-1.0-0.1*I)*(X(IC)-1.0-0.1*IC)
      ENDDO

      END

C================================================
C The subroutine "INITMOD" is called before the
C optimization. It must set a first guess
C of the parameter vector.
C It may also contain the initialization of
C the model.
C================================================
      SUBROUTINE INITMOD( N, X )
      INTEGER N
      REAL    X(N)
      INTEGER I

      DO I = 1,N
         X(I) = 1.0
      ENDDO


      END

C================================================
C The subroutine "POSTMOD" is called after
C the optimization.
C It should contain the output of the results.
C================================================
      SUBROUTINE POSTMOD( N, X, FC, ADX )

      INTEGER N
      REAL    X(N), FC, ADX(N)
      INTEGER I

      PRINT *,'**************************************'
      PRINT *,'***     RESULT OF OPTIMISATION      **'
      PRINT *,'**************************************'
      PRINT 9010, FC
      PRINT 9020
      DO I = 1,N
        PRINT 9030, I, X(I), ADX(I)
      ENDDO
 9010 FORMAT(1X,'The value of the cost function is : ',E15.9)
 9020 FORMAT(1X,'The optimal parameter values, gradients are :')
 9030 FORMAT(1X,I5,1X,E15.9,1X,E15.9)

      END
