C**********************
C*     SIMPLE_1       *
C**********************

C================================================
C This subroutine sets the number
C of control variables
C================================================
      SUBROUTINE NUMBMOD( N )
      INTEGER N
      N = 3
      END

C================================================
C The subroutine "MODEL" is called by the
C optimization procedure.
C It has to calculate the cost function "FC"
C depending on the control vector "X(N)".
C================================================
      SUBROUTINE MODEL( N, X, FC )
      INTEGER N
      REAL    X(N), FC

      REAL    A, B, C, D, E, F
      PARAMETER( A =  5., B = -4., C =  2. )
      PARAMETER( D = -2., E =  1., F = -5. )
      REAL    FC1
      INTEGER I

      FC1 = 20.0 + A*X(1) + B*X(2) + C*X(3)
     $    + D*X(1)*X(2) + E*X(2)*X(3) + F*X(1)*X(3)

      FC = 0.1*(FC1-4.0)**2
      DO I = 1,N
        FC = FC + (X(I)-FLOAT(I))**2
      ENDDO

      END

C================================================
C The subroutine "INITMOD" is called before the
C optimization. It must set a first guess
C of the parameter vector.
C It may also contain the initialization of
C the model.
C================================================
      SUBROUTINE INITMOD( N, X )

      INTEGER N
      REAL    X(N)

      X(1) = 1.0
      X(2) = 1.0
      X(3) = 1.0

      END

C================================================
C The subroutine "POSTMOD" is called after
C the optimization.
C It should contain the output of the results.
C================================================
      SUBROUTINE POSTMOD( N, X, FC, ADX )

      INTEGER N
      REAL    X(N), FC, ADX(N)
      INTEGER I

      PRINT *,'**************************************'
      PRINT *,'***     RESULT OF OPTIMISATION      **'
      PRINT *,'**************************************'
      PRINT 9010, FC
      PRINT 9020
      DO I = 1,N
        PRINT 9030, I, X(I), ADX(I)
      ENDDO
 9010 FORMAT(1X,'The value of the cost function is : ',E15.9)
 9020 FORMAT(1X,'The optimal parameter values, gradients are :')
 9030 FORMAT(1X,I5,1X,E15.9,1X,E15.9)

      END
