C**********************
C*     SIMPLE_2       *
C**********************


C================================================
C This function sets the number
C of control variables
C================================================
      SUBROUTINE NUMBMOD( N )
      INTEGER N
      N = 3
      END



      SUBROUTINE MODEL( N, X, FC )
C================================================
C The subroutine "MODEL" is called by the
C optimization procedure.
C It has to calculate the cost function "FC"
C depending on the parameter vector "X(N)".
C================================================
      INTEGER N
      REAL    X(N), FC

      REAL    EX1

      EX1 = EXP(X(1))
      FC  = EX1*( 4*X(1)**2 + 2*X(2)**2 + 4*X(1)*X(2) + 2*X(2) + 1 )

      END


      SUBROUTINE INITMOD( N, X )
C================================================
C The subroutine "INMODEL" is called before the
C optimization. It must set a first guess
C of the parameter vector.
C It may also contain the initialization of
C the model.
C================================================
      INTEGER N
      REAL    X(N)

      X(1) = -1.0
      X(2) =  1.0

      END


C================================================
C The subroutine "POSTMOD" is called after
C the optimization.
C It should contain the output of the results.
C================================================
      SUBROUTINE POSTMOD( N, X, FC )

      INTEGER N
      REAL    X(N), FC
      INTEGER I

      PRINT *,'**************************************'
      PRINT *,'***     RESULT OF OPTIMISATION      **'
      PRINT *,'**************************************'
      PRINT 9010, FC
      PRINT 9020
      DO I = 1,N
        PRINT 9030, I, X(I)
      ENDDO
 9010 FORMAT(1X,'The value of the cost function is : ',E12.6)
 9020 FORMAT(1X,'The optimal parameter values are :')
 9030 FORMAT(1X,I5,2X,E12.6)

      END
