      subroutine admodel( n, x, fc, adx, adfc )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      real a
      parameter ( a = 0.5 )
      real b
      parameter ( b = -0.4 )
      real c
      parameter ( c = 0.2 )
      real d
      parameter ( d = -0.2 )
      real e
      parameter ( e = 0.1 )
      real f
      parameter ( f = -0.5 )

C==============================================
C define arguments
C==============================================
      real adfc
      integer n
      real adx(n)
      real fc
      real x(n)

C==============================================
C define local variables
C==============================================
      real adx1
      real adx2
      real adx3
      real adxmod
      real datas(10)
      integer i
      real x1
      real x2
      real x3
      real xmod

C----------------------------------------------
C RESET LOCAL ADJOINT VARIABLES
C----------------------------------------------
      adx1 = 0.
      adx2 = 0.
      adx3 = 0.
      adxmod = 0.

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
C----------------------------------------------
C FUNCTION AND TAPE COMPUTATIONS
C----------------------------------------------
      fc = 0.
      x1 = x(1)
      x2 = x(2)
      x3 = x(3)
      do i = 1, 10
        datas(i) = i
        x1 = 0.5*x1+2.*x2-0.02
        x2 = 0.2*x2+0.5*x3+0.05
        x3 = 0.4*x3-x1-0.08
        call adstore( 'memory_1_model_x1',17,x1,8,1,i )
        call adstore( 'memory_2_model_x2',17,x2,8,1,i )
        call adstore( 'memory_3_model_x3',17,x3,8,1,i )
        xmod = a*x1+b*x2+c*x3+d*x1*x2+e*x2*x3+f*x1*x3
        call adstore( 'memory_4_model_xmod',19,xmod,8,1,i )
        fc = fc+(xmod-datas(i))*(xmod-datas(i))
      end do

C----------------------------------------------
C ADJOINT COMPUTATIONS
C----------------------------------------------
      do i = 10, 1, -1
        datas(i) = i
        call adresto( 'memory_1_model_x1',17,x1,8,1,i )
        call adresto( 'memory_2_model_x2',17,x2,8,1,i )
        call adresto( 'memory_3_model_x3',17,x3,8,1,i )
        call adresto( 'memory_4_model_xmod',19,xmod,8,1,i )
        adxmod = adxmod+2*adfc*(xmod-datas(i))
        adx1 = adx1+adxmod*(a+d*x2+f*x3)
        adx2 = adx2+adxmod*(b+d*x1+e*x3)
        adx3 = adx3+adxmod*(c+e*x2+f*x1)
        adxmod = 0.
        adx1 = adx1-adx3
        adx3 = 0.4*adx3
        adx3 = adx3+0.5*adx2
        adx2 = 0.2*adx2
        adx2 = adx2+2*adx1
        adx1 = 0.5*adx1
      end do
      adx(3) = adx(3)+adx3
      adx3 = 0.
      adx(2) = adx(2)+adx2
      adx2 = 0.
      adx(1) = adx(1)+adx1
      adx1 = 0.


      end


