      subroutine adcostcal( n )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer km
      parameter ( km = 10 )

C==============================================
C define common blocks
C==============================================
      common /advars/ adf, adfn, ads, adw, adcost
      real adcost
      real adf(km)
      real adfn(km)
      real ads(km)
      real adw

      common /cons/ delt, v, fo, a, nm, mkobs
      real a(km)
      real delt
      real fo(km)
      integer mkobs
      integer nm
      real v(km)

      common /vars/ f, fn, s, w, cost
      real cost
      real f(km)
      real fn(km)
      real s(km)
      real w

C==============================================
C define arguments
C==============================================
      integer n

C==============================================
C define local variables
C==============================================
      integer j
      integer k

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
      read(12,rec=n) (fo(k),k=1,km),(v(j),j=1,km)
      do k = 1, km
        adf(k) = adf(k)+adcost*v(k)*(f(k)-0.9*fo(k))
      end do

      end


      subroutine adfcal
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer km
      parameter ( km = 10 )

C==============================================
C define common blocks
C==============================================
      common /advars/ adf, adfn, ads, adw, adcost
      real adcost
      real adf(km)
      real adfn(km)
      real ads(km)
      real adw

      common /cons/ delt, v, fo, a, nm, mkobs
      real a(km)
      real delt
      real fo(km)
      integer mkobs
      integer nm
      real v(km)

C==============================================
C define local variables
C==============================================
      integer k

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
      do k = 1, km
        adfn(k) = adfn(k)+adf(k)
        adf(k) = 0.
      end do
      do k = 1, km
        adf(k) = adf(k)+adfn(k)
        ads(k) = ads(k)-adfn(k)*delt
        adfn(k) = 0.
      end do

      end


      subroutine admodel( nn, xx, fc, adxx, adfc )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer km
      parameter ( km = 10 )

C==============================================
C define common blocks
C==============================================
      common /advars/ adf, adfn, ads, adw, adcost
      real adcost
      real adf(km)
      real adfn(km)
      real ads(km)
      real adw

      common /cons/ delt, v, fo, a, nm, mkobs
      real a(km)
      real delt
      real fo(km)
      integer mkobs
      integer nm
      real v(km)

      common /vars/ f, fn, s, w, cost
      real cost
      real f(km)
      real fn(km)
      real s(km)
      real w

C==============================================
C define arguments
C==============================================
      real adfc
      integer nn
      real adxx(nn)
      real fc
      real xx(nn)

C==============================================
C define local variables
C==============================================
      integer help_h
      integer k
      integer n

C----------------------------------------------
C RESET GLOBAL ADJOINT VARIABLES
C----------------------------------------------
      call adzero

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
C----------------------------------------------
C OPEN FILES OF TAPE: tape
C----------------------------------------------
      open(62,file='tape_1_model_f',ACCESS='DIRECT',RECL=1*km*8)
      open(61,file='tape_2_model_w',ACCESS='DIRECT',RECL=1*8)
      open(60,file='tape_3_model_f',ACCESS='DIRECT',RECL=1*km*8)

C----------------------------------------------
C FUNCTION AND TAPE COMPUTATIONS
C----------------------------------------------
      cost = 0.
      do k = 1, nn
        f(k) = xx(k)
      end do
      do n = 1, nm
        write(62,REC=n) f
        call costcal( n )
        call wcal
        write(61,REC=n) w
        call scal
        call fcal
      end do
      write(60,REC=1) f
      help_h = nm+1
      call costcal( help_h )
      fc = cost

C----------------------------------------------
C ADJOINT COMPUTATIONS
C----------------------------------------------
      read(60,REC=1) f
      adcost = adcost+adfc
      adfc = 0.
      call adcostcal( help_h )
      do n = nm, 1, -1
        read(62,REC=n) f
        read(61,REC=n) w
        call adfcal
        call adscal
        call adwcal
        call adcostcal( n )
      end do
      do k = 1, nn
        adxx(k) = adxx(k)+adf(k)
        adf(k) = 0.
      end do

C----------------------------------------------
C CLOSE FILES OF TAPE: tape
C----------------------------------------------
      close(62)
      close(61)
      close(60)


      end


      subroutine adscal
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer km
      parameter ( km = 10 )

C==============================================
C define common blocks
C==============================================
      common /advars/ adf, adfn, ads, adw, adcost
      real adcost
      real adf(km)
      real adfn(km)
      real ads(km)
      real adw

      common /vars/ f, fn, s, w, cost
      real cost
      real f(km)
      real fn(km)
      real s(km)
      real w

C==============================================
C define local variables
C==============================================
      integer k

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
      do k = 1, km
        adf(k) = adf(k)+ads(k)*w
        adw = adw+ads(k)*f(k)
        ads(k) = 0.
      end do

      end


      subroutine adwcal
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer km
      parameter ( km = 10 )

C==============================================
C define common blocks
C==============================================
      common /advars/ adf, adfn, ads, adw, adcost
      real adcost
      real adf(km)
      real adfn(km)
      real ads(km)
      real adw

      common /cons/ delt, v, fo, a, nm, mkobs
      real a(km)
      real delt
      real fo(km)
      integer mkobs
      integer nm
      real v(km)

C==============================================
C define local variables
C==============================================
      integer k

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
      do k = 1, km
        adf(k) = adf(k)+adw*a(k)
      end do
      adw = 0.

      end


      subroutine adzero
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer km
      parameter ( km = 10 )

C==============================================
C define common blocks
C==============================================
      common /advars/ adf, adfn, ads, adw, adcost
      real adcost
      real adf(km)
      real adfn(km)
      real ads(km)
      real adw

C==============================================
C define local variables
C==============================================
      integer ip1

      do ip1 = 1, km
        adf(ip1) = 0.
      end do
      do ip1 = 1, km
        adfn(ip1) = 0.
      end do
      do ip1 = 1, km
        ads(ip1) = 0.
      end do
      adw = 0.
      adcost = 0.
      end


