      subroutine g_costcal( n )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer km
      parameter ( km = 10 )

C==============================================
C define common blocks
C==============================================
      common /cons/ delt, v, fo, a, nm, mkobs
      real a(km)
      real delt
      real fo(km)
      integer mkobs
      integer nm
      real v(km)

      common /g_vars/ g_f, g_fn, g_s, g_w, g_cost
      real g_cost
      real g_f(km)
      real g_fn(km)
      real g_s(km)
      real g_w

      common /vars/ f, fn, s, w, cost
      real cost
      real f(km)
      real fn(km)
      real s(km)
      real w

C==============================================
C define arguments
C==============================================
      integer n

C==============================================
C define local variables
C==============================================
      integer j
      integer k

C----------------------------------------------
C TANGENT LINEAR AND FUNCTION STATEMENTS
C----------------------------------------------
      read(12,rec=n) (fo(k),k=1,km),(v(j),j=1,km)
      do k = 1, km
        g_cost = g_cost+g_f(k)*v(k)*(f(k)-0.9*fo(k))
        cost = cost+0.5*v(k)*(f(k)-0.9*fo(k))**2
      end do

      end


      subroutine g_fcal
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer km
      parameter ( km = 10 )

C==============================================
C define common blocks
C==============================================
      common /cons/ delt, v, fo, a, nm, mkobs
      real a(km)
      real delt
      real fo(km)
      integer mkobs
      integer nm
      real v(km)

      common /g_vars/ g_f, g_fn, g_s, g_w, g_cost
      real g_cost
      real g_f(km)
      real g_fn(km)
      real g_s(km)
      real g_w

      common /vars/ f, fn, s, w, cost
      real cost
      real f(km)
      real fn(km)
      real s(km)
      real w

C==============================================
C define local variables
C==============================================
      integer k

C----------------------------------------------
C TANGENT LINEAR AND FUNCTION STATEMENTS
C----------------------------------------------
      do k = 1, km
        g_fn(k) = g_f(k)-g_s(k)*delt
        fn(k) = f(k)-delt*s(k)
      end do
      do k = 1, km
        g_f(k) = g_fn(k)
        f(k) = fn(k)
      end do

      end


      subroutine g_model( nn, xx, fc, g_xx, g_fc )
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer km
      parameter ( km = 10 )

C==============================================
C define common blocks
C==============================================
      common /cons/ delt, v, fo, a, nm, mkobs
      real a(km)
      real delt
      real fo(km)
      integer mkobs
      integer nm
      real v(km)

      common /g_vars/ g_f, g_fn, g_s, g_w, g_cost
      real g_cost
      real g_f(km)
      real g_fn(km)
      real g_s(km)
      real g_w

      common /vars/ f, fn, s, w, cost
      real cost
      real f(km)
      real fn(km)
      real s(km)
      real w

C==============================================
C define arguments
C==============================================
      real fc
      real g_fc
      integer nn
      real g_xx(nn)
      real xx(nn)

C==============================================
C define local variables
C==============================================
      integer help_h
      integer k
      integer n

C----------------------------------------------
C TANGENT LINEAR AND FUNCTION STATEMENTS
C----------------------------------------------
      g_cost = 0.
      cost = 0.
      do k = 1, nn
        g_f(k) = g_xx(k)
        f(k) = xx(k)
      end do
      do n = 1, nm
        call g_costcal( n )
        call g_wcal
        call g_scal
        call g_fcal
      end do
      help_h = nm+1
      call g_costcal( help_h )
      g_fc = g_cost
      fc = cost

      end


      subroutine g_scal
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer km
      parameter ( km = 10 )

C==============================================
C define common blocks
C==============================================
      common /g_vars/ g_f, g_fn, g_s, g_w, g_cost
      real g_cost
      real g_f(km)
      real g_fn(km)
      real g_s(km)
      real g_w

      common /vars/ f, fn, s, w, cost
      real cost
      real f(km)
      real fn(km)
      real s(km)
      real w

C==============================================
C define local variables
C==============================================
      integer k

C----------------------------------------------
C TANGENT LINEAR AND FUNCTION STATEMENTS
C----------------------------------------------
      do k = 1, km
        g_s(k) = g_f(k)*w+g_w*f(k)
        s(k) = f(k)*w
      end do

      end


      subroutine g_wcal
C***************************************************************
C***************************************************************
C** This routine was generated by the                         **
C** Tangent linear and Adjoint Model Compiler,  TAMC 5.2.12   **
C***************************************************************
C***************************************************************
C==============================================
C all entries are defined explicitly
C==============================================
      implicit none

C==============================================
C define parameters                            
C==============================================
      integer km
      parameter ( km = 10 )

C==============================================
C define common blocks
C==============================================
      common /cons/ delt, v, fo, a, nm, mkobs
      real a(km)
      real delt
      real fo(km)
      integer mkobs
      integer nm
      real v(km)

      common /g_vars/ g_f, g_fn, g_s, g_w, g_cost
      real g_cost
      real g_f(km)
      real g_fn(km)
      real g_s(km)
      real g_w

      common /vars/ f, fn, s, w, cost
      real cost
      real f(km)
      real fn(km)
      real s(km)
      real w

C==============================================
C define local variables
C==============================================
      integer k

C----------------------------------------------
C TANGENT LINEAR AND FUNCTION STATEMENTS
C----------------------------------------------
      g_w = 0.
      w = 0.
      do k = 1, km
        g_w = g_f(k)*a(k)+g_w
        w = w+a(k)*f(k)
      end do

      end


