C ========================================================================
      subroutine costcal(n)
      implicit none
#include "common.h"
      integer n
      integer k, j
CC      print *,'enter costcal n=', n
CC      do 10 k = 1, km
CC         fo(k) = f(k)
CC         v(k)  = 1.0
CC 10   continue
CC      write(12,rec=n) (fo(k),k=1,km),(v(k),j=1,km)
CC      print *, n

      read(12,rec=n) 
     1    (fo(k),k=1,km),(v(j),j=1,km)       ! Read in obs fo and weights v

      do 100 k=1,km                          ! for time n-1
        cost = cost+0.5*v(k)*(f(k)-0.9*fo(k))**2
 100  continue
CC      print *, n
      end

C ========================================================================
      subroutine wcal
      implicit none
#include "common.h"
      integer k

      w = 0.0
      do 100 k=1,km
        w = w+a(k)*f(k)
 100  continue
      end

C =======================================================================
      subroutine scal
      implicit none
#include "common.h"
      integer k

      do 100 k=1,km
        s(k) = f(k)*w
 100  continue
      end

C =======================================================================
      subroutine fcal             ! Steps model forward to time n
      implicit none
#include "common.h"
      integer k

      do 100 k=1,km
        fn(k) = f(k)-delt*s(k)
 100  continue
      do 200 k=1,km               ! Shift fn into f for next time loop
        f(k) = fn(k)
 200  continue
      end

C ======================================================================
      subroutine model( nn, xx, fc )
      implicit none
      integer nn
      REAL    xx(nn), fc

C   Field f is 2-d, e.g. frequency (k) and time (n).  Model implemented
C   is
C                 f(k,n)   = f(k,n-1) - s(k,n-1)*delt,
C                 s(k,n-1) = f(k,n-1)*w(n-1), 
C                              km
C                 w(n-1)   =  SUM [a(k)*f(k,n-1)],
C                             k=1
C                          nm   km
C                 cost =  SUM {SUM [v(k,n)*(f(k,n)-fo(k,n)**2]}
C                         n=0  k=1
C
C   a(k) is a set of weights defining the integral property w(n); a(k)
C   and the initial conditions f(k,0) comprise the control variables.  
C   v(k,n) is a set of weights defining the cost via the integral shown
C   and is taken as constant. v(k,n)=0 wherever there are no observations 
C   fo(k,n).
C
#include "common.h"
      integer k, n

C-------------------------------
C define file tape
C-------------------------------
CADJ INIT mytape = 'tape'


C   Begin main model loop:

      cost = 0.0                 ! Initialize cost accumulator
      do 50 k=1,nn               ! Copy np control vars into model
	f(k) = xx(k)		 
 50   continue 

C     --------------------------------------------------------------------+
      do 100 n=1,nm              ! Start loop over times n=1,nm
CADJ    STORE f = mytape	 ! TAMC saves f to a file
        call costcal(n)          ! Accumulate cost from obs at time n-1
        call wcal                ! Compute w(n-1) from f(k,n-1), a(k)
CADJ    STORE w = mytape	 ! TAMC saves w to a file
        call scal                ! Compute s(k,n-1) from w(n-1), f(k,n-1)
        call fcal                ! Step f(k,n-1) forward to f(k,n)=fn(k)
 100  continue                   ! End of time-stepping loop

C     --------------------------------------------------------------------+
CADJ  STORE f = mytape		 ! TAMC saves f to a file
      call costcal(nm+1)         ! Accumulate cost from obs at time nm
      fc = cost			 ! write final result to FC

C     --------------------------------------------------------------------+
      end 
