
#include "define.h"

#ifdef CRAY
# define DMALLOC DMALLOC
# define DMGET   DMGET
# define DMPUT   DMPUT
# define DMFREE  DMFREE
#else
# ifdef AIX
#  define DMALLOC dmalloc
#  define DMGET   dmget
#  define DMPUT   dmput
#  define DMFREE  dmfree
# else
#  define DMALLOC dmalloc_
#  define DMGET   dmget_
#  define DMPUT   dmput_
#  define DMFREE  dmfree_
# endif
#endif


/***********************************************************/
/*          DMALLOC                                        */
/***********************************************************/
Void
DMALLOC( dm, byte, ifail )
     Void    **dm;
     FORINT  *byte;
     FORINT  *ifail;
{
  if ( (*dm = (Void *) malloc( (size_t) *byte )) == NULL )
    {
      fprintf( stderr, "DMPUT : malloc failed\n" );
      *ifail = 1;
    }
  else
    {
      *ifail = 0;
    }
}


/***********************************************************/
/*          DMPUT                                          */
/***********************************************************/
Void
DMPUT( dm, ptr, size, items )
     Void    **dm;
     Void    *ptr;
     FORINT  *size;
     FORINT  *items;
{
  FORINT ifail;
  FORINT byte;

  byte = (*size)*(*items);

  DMALLOC( dm, &byte, &ifail );
  if ( ifail == 0 )
    memcpy( *dm, ptr, (size_t) byte );
}


/***********************************************************/
/*          DMGET                                          */
/***********************************************************/
Void
DMGET( dm, ptr, size, items )
     Void    **dm;
     Void    *ptr;
     FORINT  *size;
     FORINT  *items;
{
  memcpy( ptr, *dm, (size_t) (*size)*(*items) );
}


/***********************************************************/
/*          DMFREE                                         */
/***********************************************************/
Void
DMFREE( dm )
     Void    **dm;
{
  free( (*dm) );
}
