
#include "define.h"
#include "tsearch.h"

typedef struct avltree_node {
  Void *item;
  int bal;
  struct avltree_node *left, *right;
} avltree_node;

typedef     int (*compare) PP((Const Void *, Const Void *));



struct LOC_tsearch {
  void **Result;
  compare comp;
} ;

Void search( x, p, h, LINK )
     Void *x;
     avltree_node **p;
     boolean *h;
     struct LOC_tsearch *LINK;
{
  avltree_node *p1, *p2;
  int delta;
  avltree_node *WITH;

  if (*p == NULL) {
    *p = (avltree_node *) malloc(sizeof(avltree_node));
    *h = true;
    WITH = *p;
    WITH->item = x;
    WITH->left = NULL;
    WITH->right = NULL;
    WITH->bal = 0;
    LINK->Result = &( (*p)->item );
    return;
  }
  delta = ( (int(*)PP((Void *a, Void *b))) LINK->comp) (x,(*p)->item);
  if (delta < 0) {
    search(x, &(*p)->left, h, LINK);
    if (!*h)
      return;
    switch ((*p)->bal) {

    case 1:
      (*p)->bal = 0;
      *h = false;
      break;

    case 0:
      (*p)->bal = -1;
      break;

    case -1:
      p1 = (*p)->left;
      if (p1->bal == -1) {
	(*p)->left = p1->right;
	p1->right = *p;
	(*p)->bal = 0;
	*p = p1;
      } else {
	p2 = p1->right;
	p1->right = p2->left;
	p2->left = p1;
	(*p)->left = p2->right;
	p2->right = *p;
	if (p2->bal == -1)
	  (*p)->bal = 1;
	else
	  (*p)->bal = 0;
	if (p2->bal == 1)
	  p1->bal = -1;
	else
	  p1->bal = 0;
	*p = p2;
      }
      (*p)->bal = 0;
      *h = false;
      break;
    }
    return;
  }
  if (delta <= 0) {
    *h = false;
    LINK->Result = &( (*p)->item );
    return;
  }
  search(x, &(*p)->right, h, LINK);
  if (!*h)
    return;
  switch ((*p)->bal) {

  case -1:
    (*p)->bal = 0;
    *h = false;
    break;

  case 0:
    (*p)->bal = 1;
    break;

  case 1:
    p1 = (*p)->right;
    if (p1->bal == 1) {
      (*p)->right = p1->left;
      p1->left = *p;
      (*p)->bal = 0;
      *p = p1;
    } else {
      p2 = p1->left;
      p1->left = p2->right;
      p2->right = p1;
      (*p)->right = p2->left;
      p2->left = *p;
      if (p2->bal == 1)
	(*p)->bal = -1;
      else
	(*p)->bal = 0;
      if (p2->bal == -1)
	p1->bal = 1;
      else
	p1->bal = 0;
      *p = p2;
    }
    (*p)->bal = 0;
    *h = false;
    break;
  }
}


Void *tsearch( x, root, comp )
     Const Void *x;
     Void **root;
     compare comp;
{
  struct LOC_tsearch V;
  boolean h;

  V.comp = comp;
  search(x, (avltree_node **) root, &h, &V);
  return (Void *) V.Result;
}



Void walk( p, level, action )
     Const avltree_node *p;
     int level;
     twalk_action action;
{
  if (p == NULL)
    return;

  if (p->left == NULL && p->right == NULL) {
    action(p->item, leaf, level);
    return;
  } else {
    action(p->item, preorder, level);
    walk(p->left, level+1, action);

    action(p->item, postorder, level);

    walk(p->right, level+1, action);

    action(p->item, endorder, level);
  }
}


Void twalk( root, action )
     Const Void *root;
     twalk_action action;
{
  if (root != NULL)
    walk( (avltree_node *) root, 0, action);
}
