      SUBROUTINE CSTGRAD( N, X, FC, ADX )
C********************************************************************
C
C input  : N      amount of parameters
C          X      array of parameters
C
C output : FC     value of cost function
C          ADX    gradient of cost function
C
C********************************************************************
      IMPLICIT NONE

      INTEGER N
      REAL    X(N), FC, ADX(N), ADFC
      INTEGER I

C==============================================
C initialize adjoint variables
C==============================================
      DO I = 1, N
        ADX(I) = 0.0
      END DO
      ADFC = 1.0

C==============================================
C compute gradient and cost function
C==============================================
      CALL ADMODEL ( N, X, FC, ADX, ADFC )

      END
