
#if (REAL_BYTE == 8)
# ifndef CRAY
#  define X02AJE X02AJF
# endif
# define EPS    1.e-10
#else
# define EPS    1.e-4
#endif

      subroutine hessian( n, x0, objf, adx0, h )
C*******************************************************
C calculate the hessian matrix
C by finite differences of gradients
C*******************************************************
c==================================================
c     declaration part
c==================================================
      integer n
      REAL    x0(n), objf, adx0(n), h(n,n)

      REAL       fac
      parameter( fac = 1.E+10 )

      integer i,k

      REAL    fc
      REAL    deltx

      REAL     X02AJE 
      external X02AJE

      REAL    eps, xmem
c     REAL    grd

c==================================================
c     calculation
c==================================================
      eps = EPS
cccc      eps = X02AJE()
cccc      print *,' eps = ',eps
      do i=1,n

c==================================================
c     calculation of steplenth deltx 
c==================================================
cold     grd   = amax1( abs(adx0(i)), fac*eps )
         deltx = eps
cccc     print *,' deltx (',i,') = ',deltx

         xmem  = x0(i)
         x0(i) = x0(i) + deltx

c==================================================
c     calculation of gradient h(1,i)
c==================================================
         CALL CSTGRAD( N, X0, FC, H(1,I) )

c==================================================
c     calculation of gradient h(1,i)
c==================================================
         do k = 1,n
            h(k,i) = (h(k,i)-adx0(k)) / deltx
         enddo

c==================================================
c     reset x0
c==================================================
         x0(i) = xmem

      enddo

      end
