
#if (REAL_BYTE == 8)
# define Xx2AJE Xx2AJF
# define EPS    1.e-10
#else
# define EPS    1.e-4
#endif

      subroutine hessian( nn, xx, fc, adxx, hess )
C*******************************************************
C calculate the hessian matrix
C using the adjoint model
C*******************************************************
c==================================================
c     declaration part
c==================================================
      integer nn
      REAL    xx(nn), fc, adxx(nn), hess(nn,nn)

      integer i,k

      REAL    fc1
      REAL    deltx

      REAL    eps, xmem

c==================================================
c     calculation
c==================================================
      eps = EPS

      do i = 1,nn

c==================================================
c     calculation of steplenth deltx 
c==================================================
         deltx = eps

         xmem  = xx(i)
         xx(i) = xx(i) + deltx

c==================================================
c     calculation of gradient hess(1,i)
c==================================================
         call cstgrad( nn, xx, fc1, hess(1,i) )

c==================================================
c     calculation of gradient hess(1,i)
c==================================================
         do k = 1,nn
            hess(k,i) = (hess(k,i)-adxx(k)) / deltx
         enddo

c==================================================
c     reset xx
c==================================================
         xx(i) = xmem

      enddo

      end
