
#if (REAL_BYTE == 8)
# define X02AJE X02AJF
# define EPS    1.e-8
#else
# define EPS    1.e-6
#endif

      subroutine hessvec( nn, xx, fc, adxx, vout, vin )
C*******************************************************
C calculate the hessian times vector
C by finite differences of gradients
C*******************************************************
c==================================================
c     declaration part
c==================================================
      implicit none

      integer nn
      REAL    xx(nn), fc, adxx(nn), vout(nn), vin(nn)

      integer i
      REAL    fc1, deltx, xnorm

c==================================================
c     calculation of steplength deltx 
c==================================================
      deltx = EPS

      xnorm = 0.0
      do i = 1,nn
        xnorm = xnorm + vin(i)*vin(i)
      end do
      xnorm = sqrt(xnorm)

c==================================================
c     set xx
c==================================================
      do i = 1,nn
        xx(i) = xx(i) + vin(i)*deltx/xnorm
      end do

c==================================================
c     calculation of gradient
c==================================================
      call cstgrad( nn, xx, fc1, vout )

c==================================================
c     compute finite differences
c==================================================
      do i = 1,nn
         vout(i) = (vout(i)-adxx(i))*xnorm / deltx
      enddo

c==================================================
c     reset xx
c==================================================
      do i = 1,nn
        xx(i) = xx(i) - vin(i)*deltx/xnorm
      end do

      end
