      SUBROUTINE MYALLOC( PWORK, LWORK )
C********************************************************************
C Fortran routine to allocate dynamic work space
C ----------------------------------------------
C
C input  : LWORK  = length in words (cray) or bytes (SUN,Convex)
C
C output : PWORK  = INTEGER or POINTER to allocated memory
C
C********************************************************************
      IMPLICIT NONE

      INTEGER LWORK

#ifdef CRAY
#define _IS_ALLOC_
C--------------------------------
C Cray FORTRAN memory allocation
C IABORT=0 request an error code
C--------------------------------
      REAL    XX
      POINTER (PWORK,XX)

      INTEGER IERR, IABORT

      IERR   = 0
      IABORT = 0
      CALL HPALLOC( PWORK, LWORK, IERR, IABORT )
      IF (IERR .NE. 0) THEN
        PRINT *, 'HPALLOC : IERR = ', IERR
        STOP 'ERROR IN MYALLOC'
      ENDIF
#endif


#ifdef HP
#define _IS_ALLOC_
C--------------------------------
C HP Fortran provides MALLOC,
C--------------------------------
      INTEGER PWORK

      CALL MALLOC( LWORK, PWORK )
#endif


#ifdef SGI
#define _IS_ALLOC_
C--------------------------------
C SGI Fortran provides MALLOC
C--------------------------------
      REAL    XX
      POINTER (PWORK,XX)

      PWORK = MALLOC(LWORK)
#endif


#ifdef AIX
#define _IS_ALLOC_
C--------------------------------
C ANSI-C memory allocation
C--------------------------------
      INTEGER  PWORK

      INTEGER  MALLOC
      EXTERNAL MALLOC
      PWORK = MALLOC( %VAL( LWORK ) )
#endif


#ifdef ALPHA
#define _IS_ALLOC_
C--------------------------------
C DEC Alpha
C use c-routine
C--------------------------------
      REAL    XX
      POINTER (PWORK,XX)
      EXTERNAL CCALLOC

      CALL CCALLOC( LWORK, PWORK )
#endif


#if defined(SUN) || defined(DEC) || defined(LINUX)
#define _IS_ALLOC_
C--------------------------------
C SUN f77
C--------------------------------
      INTEGER  PWORK
      INTEGER  MALLOC
      EXTERNAL MALLOC
      PWORK = MALLOC( LWORK )
#endif


#ifndef _IS_ALLOC_
C--------------------------------
C otherwise use C-malloc
C--------------------------------
      INTEGER  PWORK
      INTEGER  MALLOC
      EXTERNAL MALLOC
      PWORK = MALLOC( LWORK )
#endif


C--------------------------------
C check pointer
C--------------------------------
#ifndef CRAY
      IF ( PWORK .EQ. 0 )   THEN
        PRINT *, 'MYALLOC : MALLOC ERROR'
        STOP 'ERROR'
      ENDIF
#endif

      END
