      SUBROUTINE MYFREE( PWORK )
C********************************************************************
C Fortran routine to deallocate dynamic memory
C --------------------------------------------
C
C input : PWORK  = INTEGER or POINTER to allocated memory
C
C********************************************************************
      IMPLICIT NONE

#if defined(CRAY)
C----------------------------------
C Cray FORTRAN memory deallocation
C IABORT=0 requests an error code
C----------------------------------
      REAL XX
      POINTER (PWORK,XX)

      INTEGER IERR, IABORT

      IERR   = 0
      IABORT = 0
      CALL HPDEALLC( PWORK, IERR, IABORT )

      IF (IERR .NE. 0) THEN
        PRINT *, 'HPDEALLC : IERR = ', IERR
        STOP 'ERROR IN HPDEALLC'
      ENDIF

C--------------------------------
C does HP fortran provide FREE??
C--------------------------------
#elif defined(HP) || defined(SUN)
      INTEGER PWORK

      CALL FREE( PWORK )

C--------------------------------
C does AIX fortran provide FREE??
C--------------------------------
#elif defined(AIX)
      INTEGER  PWORK, IERR

      INTEGER  FREE
      EXTERNAL FREE
      IERR = FREE( PWORK )

C--------------------------------
C does ALPHA fortran provide FREE??
C--------------------------------
#elif defined(ALPHA)
      REAL XX
      POINTER (PWORK,XX)
      INTEGER  FREE, IERR
      EXTERNAL FREE

      IERR = FREE( PWORK )

C--------------------------------
C ANSI-C memory deallocation
C--------------------------------
#else
      INTEGER  PWORK
      INTEGER  IERR
      INTEGER  FREE
      EXTERNAL FREE
      IERR = FREE( PWORK )

#endif

      END
