#include "define.h"

      subroutine minstab( nn, xx, meig, kiter, noits
     $                  , evec, eval, tol )
C********************************************************************
C
C********************************************************************
      implicit none

C==============================================================
C declare call parameter
C==============================================================
      integer nn, meig, kiter, noits
      REAL    xx(nn), evec(nn,kiter), eval(kiter), tol

C==============================================================
C declare local variables
C==============================================================
      integer novecs
      external xdot, image, monit
      REAL     xdot

      integer liwork
      parameter ( liwork = 1 )
      REAL    iwork(liwork)

      integer lwork
      integer lrwork

#if defined(USE_POINTER) || (MAX_INDEPEND == 0)
      REAL    work
      pointer (pwork,work(1))
      REAL    rwork
      pointer (prwork,rwork(1))
#else
      INTEGER nmax
      PARAMETER( nmax = MAX_INDEPEND )
      REAL    work(nmax/2 + 2*nmax)
      INTEGER rwork(2*nmax)
#endif

      integer i, ifail, nrx
      REAL    fc

C======================================================
C set some constants
C======================================================
      lwork  = 3*kiter + max0(kiter*kiter,2*nn)
      lrwork = 2*nn

C======================================================
C allocate working space for f02fje
C======================================================
#if defined(USE_POINTER) || (MAX_INDEPEND == 0)
#  ifdef CRAY
      CALL MYALLOC( pwork , lwork  )
      CALL MYALLOC( prwork, lrwork )
#  else
      CALL MYALLOC( pwork , lwork *REAL_BYTE )
      CALL MYALLOC( prwork, lrwork*REAL_BYTE )
#  endif
#endif

      do i = 1, lwork
        work(i) = 0.0
      end do

C==============================================================
C compute gradient at central point
C==============================================================
      do i = 1,nn
        rwork(i) = xx(i)
      end do

      call cstgrad( nn, rwork, fc, rwork(nn+1) )

C==============================================================
C start
C==============================================================
      novecs = 0
      ifail  = 1
      nrx    = nn

      if (nn .lt. 1) then
        print '(a)', ' n < 1'
      end if

      if (meig .lt. 1) then
        print '(a)', ' m < 1'
      else if (meig .ge. kiter) then
        print '(a)', ' m >= kiter'
      end if

      if (kiter .gt. nn) then
        print '(a)', ' k > n'
      end if

      call F02FJE( nn, meig, kiter, noits, tol, xdot, image, monit
     $           , novecs, evec, nrx, eval, work, lwork
     $           , rwork, lrwork, iwork, liwork, ifail )


      print *,' OPTIMI : AFTER F02FJE IFAIL = ', ifail

      end
