#include "define.h"

      program main
C*************************************************************
      implicit none

c=========================================
c declaration
c=========================================
      integer n

C==============================================================
C get the number of control variables
C==============================================================
      call numbmod( n )

c-----------------------------------------
c call the subroutine
c-----------------------------------------
      call adjoint( n )

      end


      SUBROUTINE ADJOINT( N )
C**********************************************************************
C checks the output computed by the reverse and forward mode
C**********************************************************************
      IMPLICIT NONE

      INTEGER N
      REAL    ADFC

#if   defined(DYNAMIC)
      REAL    X(N)
      REAL    ADX(N)
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      REAL    X, ADX
      POINTER (PX,X(1))
      POINTER (PADX,ADX(1))
#else
      INTEGER NMAX
      PARAMETER( NMAX = MAX_INDEPEND )
      REAL    X(NMAX)
      REAL    ADX(NMAX)
#endif

C====================================
C local variables
C====================================
      INTEGER I
      REAL    FC

C==============================================================
C allocate memory for the control variables
C and the gradient vector
C==============================================================
#if   defined(DYNAMIC)
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      CALL MYALLOC( PX  , N*REAL_BYTE )
      CALL MYALLOC( PADX, N*REAL_BYTE )
#endif

C==============================================================
C initialisize the model
C and set the first guess of the control variables
C==============================================================
      CALL INITMOD( N, X )

C==============================================================
C call adjoint model code
C==============================================================
      PRINT *
      PRINT '(A)', '================================================='
      PRINT '(A)', '    COMPUTATION OF FUNCTION AND DERIVATIVES'
      PRINT '(A)', '    IN REVERSE MODE'
      PRINT '(A)', '================================================='

      DO I = 1, N
        ADX(I) = 0.0
      END DO
      ADFC = 1.0
      CALL ADMODEL( N, X, FC, ADX, ADFC )

C==============================================================
C postprocessing
C==============================================================
      CALL POSTMOD( N, X, FC, ADX )

      END
