#include "define.h"

      program main
C*************************************************************
      implicit none

c=========================================
c declaration
c=========================================
      integer n, m

C==============================================================
C get the number of the independent and dependent variables
C==============================================================
      call setfunc( n, m )

c-----------------------------------------
c call the subroutine
c-----------------------------------------
      call forward( n, m )

      end


      SUBROUTINE FORWARD( N, M )
C==============================================================
C declaration
C==============================================================
      IMPLICIT NONE

      INTEGER N, M

      INTEGER NPG

#if defined(DYNAMIC)
      REAL   X(N)
      REAL   Y(M)
      REAL   GDX(N,N)
      REAL   GDY(N,M)
      INTEGER NMAX, MMAX
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      REAL    X, Y, GDX, GDY
      POINTER (PX,X(1))
      POINTER (PY,Y(1))
      POINTER (PGDX,GDX(1))
      POINTER (PGDY,GDY(1))
      INTEGER NMAX, MMAX
#else
      INTEGER NMAX, MMAX
      PARAMETER( NMAX = MAX_INDEPEND, MMAX = MAX_DEPEND )
      REAL   X(NMAX)
      REAL   Y(MMAX)
      REAL   GDX(NMAX,NMAX)
      REAL   GDY(NMAX,MMAX)
#endif

C==============================================================
C==============================================================
      NPG = N

C==============================================================
C allocate memory for the control variables
C and the gradient vector
C==============================================================
#if defined(DYNAMIC)
      NMAX = N
      MMAX = M
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      NMAX = N
      MMAX = M

      CALL MYALLOC( PX   , N*REAL_BYTE )
      CALL MYALLOC( PY   , M*REAL_BYTE )
      CALL MYALLOC( PGDX , N*N*REAL_BYTE )
      CALL MYALLOC( PGDY , N*M*REAL_BYTE )
#endif

C==============================================================
C initialisize the model
C and set the first guess of the control variables
C==============================================================
      CALL INITFUNC( N, X )

C==============================================================
C compute jacobian by forward mode
C==============================================================
      PRINT *
      PRINT '(A)', '================================================='
      PRINT '(A)', '    COMPUTATION OF FUNCTION AND JACOBIAN'
      PRINT '(A)', '    IN FORWARD MODE'
      PRINT '(A)', '================================================='

      CALL SIDENT( N, GDX, NMAX )
      CALL G_FUNC( N, X, M, Y, NPG, GDX, NMAX, GDY, NMAX )

C==============================================================
C postprocessing
C==============================================================
      CALL POSTFUNC( N, X, M, Y, GDY, NMAX )

      END
