#include "define.h"

      program main
C*************************************************************
      implicit none

c=========================================
c declaration
c=========================================
      integer n, m

C==============================================================
C get the number of the independent and dependent variables
C==============================================================
      call setfunc( n, m )

c-----------------------------------------
c call the subroutine
c-----------------------------------------
      call dofunc( n, m )

      end


      SUBROUTINE DOFUNC( N, M )
C==============================================================
C declaration
C==============================================================
      IMPLICIT NONE

      INTEGER N, M

#if defined(DYNAMIC)
      REAL   X(N)
      REAL   Y(M)
      INTEGER NMAX, MMAX
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      REAL    X, Y
      POINTER (PX,X(1))
      POINTER (PY,Y(1))
      INTEGER NMAX, MMAX
#else
      INTEGER NMAX, MMAX
      PARAMETER( NMAX = MAX_INDEPEND, MMAX = MAX_DEPEND )
      REAL   X(NMAX)
      REAL   Y(MMAX)
#endif

C==============================================================
C allocate memory for the control variables
C and the gradient vector
C==============================================================
#if defined(DYNAMIC)
      NMAX = N
      MMAX = M
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      NMAX = N
      MMAX = M

      CALL MYALLOC( PX   , N*REAL_BYTE )
      CALL MYALLOC( PY   , M*REAL_BYTE )
#endif

C==============================================================
C initialisize the model
C and set the first guess of the control variables
C==============================================================
      CALL INITFUNC( N, X )

C==============================================================
C compute function
C==============================================================
      CALL FUNC( N, X, M, Y )

C==============================================================
C postprocessing set
C==============================================================
      CALL POSTFUNC( N, X, M, Y, Y, NMAX )

      END
