#include "define.h"

      PROGRAM MAIN
C*************************************************************
      implicit none

c=========================================
c declaration
c=========================================
      integer n

C==============================================================
C get the number of control variables
C==============================================================
      call numbmod( n )

c-----------------------------------------
c call the subroutine
c-----------------------------------------
      call hessi( n )

      end


      SUBROUTINE HESSI( N )
C==============================================================
C declaration
C==============================================================
      IMPLICIT NONE

      INTEGER N

#if defined(DYNAMIC)
      REAL   X(N)
      REAL   ADX(N)
      REAL   XH(N*N)
      REAL   G_X(N*N)
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      REAL    X, ADX
      POINTER (PX,X(1))
      POINTER (PADX,ADX(1))
      REAL    XH
      POINTER (PXH,XH(1))
      REAL     G_X
      POINTER (PG_X,G_X(1))
#else
      INTEGER NMAX
      PARAMETER( NMAX = MAX_INDEPEND )
      REAL   X(NMAX)
      REAL   ADX(NMAX)
      REAL   XH(NMAX*NMAX)
      REAL   G_X(NMAX*NMAX)
#endif

      INTEGER I, J
      REAL    OBJF

C==============================================================
C allocate memory for the control variables
C and the gradient vector
C==============================================================
#if defined(DYNAMIC)
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      CALL MYALLOC( PX     , N*REAL_BYTE )
      CALL MYALLOC( PADX   , N*REAL_BYTE )
      CALL MYALLOC( PG_X   , N*N*REAL_BYTE )
      CALL MYALLOC( PXH    , N*N*REAL_BYTE )
#endif

C==============================================================
C initialisize the model
C and set the first guess of the control variables
C==============================================================
      CALL INITMOD( N, X )

C===============================================
C forward model
C adjoint model
C===============================================
      CALL SIDENT( N, G_X, N )

      CALL G_CSTGRAD( N, X, OBJF, ADX, G_X, XH )

C==============================================================
C start of postprocessor
C==============================================================
      CALL POSTMOD( N, X, OBJF, ADX )

C===============================================
C print eigenvalues and eigenvectors
C===============================================
      print *
      print *,'  j     hess(1:n,j) '
      do j = 1,n
        print '(i3,5(x,e12.6))', j, (xh(i+(j-1)*n),i=1,n)
      enddo

      END
