#include "define.h"

      PROGRAM MAIN
C*************************************************************
      implicit none

c=========================================
c declaration
c=========================================
      integer n, m

C==============================================================
C get the number of the independent and dependent variables
C==============================================================
      call setfunc( n, m )

c-----------------------------------------
c call the subroutine
c-----------------------------------------
      call jacob( n, m )

      end


      SUBROUTINE JACOB( N, M )
C==============================================================
C declaration
C==============================================================
      IMPLICIT NONE

      INTEGER N, M, NPA, NPG

#if defined(DYNAMIC)
      REAL   X(N)
      REAL   Y(M)
      REAL   ADX(M,N)
      REAL   ADY(M,M)
      REAL   GDX(N,N)
      REAL   GDY(N,M)
      INTEGER NMAX, MMAX
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      REAL    X, Y, ADX, ADY, GDX, GDY
      POINTER (PX,X(1))
      POINTER (PY,Y(1))
      POINTER (PADX,ADX(1))
      POINTER (PADY,ADY(1))
      POINTER (PGDX,GDX(1))
      POINTER (PGDY,GDY(1))
      INTEGER NMAX, MMAX
#else
      INTEGER NMAX, MMAX
      PARAMETER( NMAX = MAX_INDEPEND, MMAX = MAX_DEPEND )
      REAL   X(NMAX)
      REAL   Y(MMAX)
      REAL   ADX(MMAX,NMAX)
      REAL   ADY(MMAX,MMAX)
      REAL   GDX(NMAX,NMAX)
      REAL   GDY(NMAX,MMAX)
#endif

C==============================================================
C==============================================================
      NPA = M
      NPG = N

C==============================================================
C allocate memory for the control variables
C and the gradient vector
C==============================================================
#if defined(DYNAMIC)
      NMAX = N
      MMAX = M
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      NMAX = N
      MMAX = M

      CALL MYALLOC( PX   , N*REAL_BYTE )
      CALL MYALLOC( PY   , M*REAL_BYTE )
      CALL MYALLOC( PADX , M*N*REAL_BYTE )
      CALL MYALLOC( PADY , M*M*REAL_BYTE )
      CALL MYALLOC( PGDX , N*N*REAL_BYTE )
      CALL MYALLOC( PGDY , N*M*REAL_BYTE )
#endif

C==============================================================
C initialisize the model
C and set the first guess of the control variables
C==============================================================
      CALL INITFUNC( N, X )

C==============================================================
C compute jacobian by reverse mode
C==============================================================
      CALL SIDENT( M, ADY, MMAX )
      CALL SZERO2( M, N, ADX, MMAX )

      CALL ADFUNC( N, X, M, Y, NPA, ADX, MMAX, ADY, MMAX )

      CALL STRANS( M, N, ADX, MMAX, GDY, NMAX )

      PRINT *
      PRINT '(A)', '======== reverse mode ========='
      CALL POSTFUNC( N, X, M, Y, GDY, NMAX )

C==============================================================
C compute jacobian by forward mode
C==============================================================
      CALL SIDENT( N, GDX, NMAX )
      CALL G_FUNC( N, X, M, Y, NPG, GDX, NMAX, GDY, NMAX )

      PRINT *
      PRINT '(A)', '======== forward mode ========='
      CALL POSTFUNC( N, X, M, Y, GDY, NMAX )

      END
