#include "define.h"

      PROGRAM MAIN
C*************************************************************
      implicit none

c=========================================
c declaration
c=========================================
      integer n

C==============================================================
C get the number of control variables
C==============================================================
      call numbmod( n )

c-----------------------------------------
c call the subroutine
c-----------------------------------------
      call opti( n )

      end


      SUBROUTINE OPTI( N )

      IMPLICIT NONE

      INTEGER N
      REAL    OBJF

#if defined(DYNAMIC)
      REAL   X(N)
      REAL   ADX(N)
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      REAL    X, ADX
      POINTER (PX,X(1))
      POINTER (PADX,ADX(1))
#else
      INTEGER NMAX
      PARAMETER( NMAX = MAX_INDEPEND )
      REAL   X(NMAX)
      REAL   ADX(NMAX)
#endif

C==============================================================
C allocate memory for the control variables
C and the gradient vector
C==============================================================
#if defined(DYNAMIC)
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      CALL MYALLOC( PX  , N*REAL_BYTE )
      CALL MYALLOC( PADX, N*REAL_BYTE )
#endif

C==============================================================
C initialisize the model
C and set the first guess of the control variables
C==============================================================
      CALL INITMOD( N, X )

C==============================================================
C optimize the costfunction using control variables
C==============================================================
      CALL OPTIMUM( N, X, OBJF, ADX )

C==============================================================
C start of postprocessor
C==============================================================
      CALL POSTMOD( N, X, OBJF, ADX )

      END

