#include "define.h"

      program main
C*************************************************************
      implicit none

c=========================================
c declaration
c=========================================
      integer n, m

C==============================================================
C get the number of the independent and dependent variables
C==============================================================
      call setfunc( n, m )

c-----------------------------------------
c call the subroutine
c-----------------------------------------
      call reverse( n, m )

      end


      SUBROUTINE REVERSE( N, M )
C**********************************************************************
C checks the output computed by the reverse and forward mode
C**********************************************************************
      IMPLICIT NONE

      INTEGER N, M

      INTEGER NPA

#if defined(DYNAMIC)
      REAL   X(N)
      REAL   Y(M)
      REAL   ADX(M,N)
      REAL   ADY(M,M)
      REAL   GDX(N,M)
      INTEGER NMAX, MMAX
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      REAL    X, Y
      REAL    ADX, ADY
      REAL    GDX
      POINTER (PX,X(1))
      POINTER (PY,Y(1))
      POINTER (PADX,ADX(1))
      POINTER (PADY,ADY(1))
      POINTER (PGDX,GDX(1))
      INTEGER NMAX, MMAX
#else
      INTEGER NMAX, MMAX
      PARAMETER( NMAX = MAX_INDEPEND, MMAX = MAX_DEPEND )
      REAL   X(NMAX)
      REAL   Y(MMAX)
      REAL   ADX(MMAX,NMAX)
      REAL   ADY(MMAX,MMAX)
      REAL   GDX(NMAX,MMAX)
#endif

C==============================================================
C==============================================================
      NPA = M

C==============================================================
C allocate memory for the input output variables
C and there derivatives
C==============================================================
#if defined(DYNAMIC)
      NMAX = N
      MMAX = M
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      NMAX = N
      MMAX = M

      CALL MYALLOC( PX   , N*REAL_BYTE )
      CALL MYALLOC( PY   , M*REAL_BYTE )
      CALL MYALLOC( PADX , M*N*REAL_BYTE )
      CALL MYALLOC( PADY , M*M*REAL_BYTE )
      CALL MYALLOC( PGDX , N*M*REAL_BYTE )
#endif

C==============================================================
C initialisize the model
C and set the first guess of the control variables
C==============================================================
      CALL INITFUNC( N, X )

C==============================================================
C compute jacobian in reverse mode
C==============================================================
      PRINT *
      PRINT '(A)', '================================================='
      PRINT '(A)', '    COMPUTATION OF FUNCTION AND JACOBIAN'
      PRINT '(A)', '    IN REVERSE MODE'
      PRINT '(A)', '================================================='

      CALL SZERO2( M, N, ADX, MMAX )
      CALL SIDENT( M,    ADY, MMAX )
      CALL ADFUNC( N, X, M, Y, NPA, ADX, MMAX, ADY, MMAX )

C==============================================================
C postprocessing
C==============================================================
      CALL STRANS( M, N, ADX, MMAX, GDX, NMAX )

      CALL POSTFUNC( N, X, M, Y, GDX, MMAX )

      END
