#include "define.h"

      program main
C*************************************************************
      implicit none

c=========================================
c declaration
c=========================================
      integer n

C==============================================================
C get the number of control variables
C==============================================================
      call numbmod( n )

c-----------------------------------------
c call the subroutine
c-----------------------------------------
      call tangent( n )

      end


      SUBROUTINE TANGENT( N )
C**********************************************************************
C checks the output computed by the reverse and forward mode
C**********************************************************************
      IMPLICIT NONE

      INTEGER N

#if defined(DYNAMIC)
      REAL    X(N)
      REAL    GDX(N)
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      REAL    X, GDX
      POINTER (PX,X(1))
      POINTER (PGDX,GDX(1))
#else
      INTEGER NMAX
      PARAMETER( NMAX = MAX_INDEPEND )
      REAL    X(NMAX)
      REAL    GDX(NMAX)
#endif

C====================================
C local variables
C====================================
      REAL    FC, GDFC

C==============================================================
C allocate memory for the control variables
C and the gradient vector
C==============================================================
#if defined(DYNAMIC)
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      CALL MYALLOC( PX  , N*REAL_BYTE )
      CALL MYALLOC( PGDX, N*REAL_BYTE )
#endif

C==============================================================
C initialisize the model
C and set the first guess of the control variables
C==============================================================
      CALL INITMOD( N, X )

C==============================================================
C==============================================================
      CALL INITPER( N, GDX )

C==============================================================
C call adjoint model code
C==============================================================
      PRINT *
      PRINT '(A)', '================================================='
      PRINT '(A)', '    COMPUTATION OF FUNCTION AND DERIVATIVES'
      PRINT '(A)', '    IN FORWARD MODE'
      PRINT '(A)', '================================================='

      CALL G_MODEL( N, X, FC, GDX, GDFC )

C==============================================================
C postprocessing
C==============================================================
      print *
      print '(a,e14.6)', ' the cost function is : ', fc
      print '(a,e14.6)', ' its pertubation   is : ', gdfc


      END
